;Uses the interrupt test program as base.. I also added a lot of comments
;for those who may have trouble.  The interrupt routine is entirely
;my own. The programs basic job is: If no buttons are pressed for about 30
;seconds, it turns off the calc and exits the program. The call to $0C29
;exits the program, so i can't do anything about that unless I disassemble
;that call.. Might do it later.. This can be changed to do some other things,
;but if you use this code or change it, give me some credit..
;
;Jim Alverson   email: jima@tso.org

#include "asm86.h"
#include "ti86asm.inc"

_user_int_ram EQU $d2fd                 ;Area where interrupt handler goes..

.org _asm_exec_ram
   res 2,(iy+$23)                       ;turn user int off so it won't get called by
                                        ;accident before we're ready
   
   ld hl,int                            ;copy prog to user int buffer
   ld de,_user_int_ram+1
   ld bc,int_end-int                    ;length of handler
   ldir                                 ;hl is the source, de is the destination,
                                        ;and bc is the length
   
   ld a,(_user_int_ram+1)               ;set up checksum byte
   ld hl,_user_int_ram+($28*1)          ;load byte
   add a,(hl)                           ;add to total
   ld hl,_user_int_ram+($28*2)          ;load byte
   add a,(hl)                           ;add to total
   ld hl,_user_int_ram+($28*3)          ;load byte
   add a,(hl)                           ;add to total
   ld hl,_user_int_ram+($28*4)          ;load byte
   add a,(hl)                           ;add to total
   ld hl,_user_int_ram+($28*5)          ;load byte
   add a,(hl)                           ;add to total
   ld (_user_int_ram),a                 ;load checksum in its location

   set 2,(iy+$23)                       ;turn it on
   ret


int:
   push af                              ;save registers.. MUST DO.. your calculator
   push hl                              ;will crash if you don't
   push bc
   ld a,0                               ;mask of 0 means check every row
   out (1),a                            ;send mask to port
   in a,(1)                             ;get keys being pressed
   cp 255                               ;if all bits are set, no keys are being
                                        ;pressed
   jr z,do                              ;no keys being pressed, jump to 'do'
   jr nz,end2                           ;otherwise jump to 'end2'
do: 
   ld hl,var1                           ;load variable into hl
   dec (hl)                             ;decrement
   jr z,next                            ;if variable is zero, jump to 'next'
   jr nz,end1                           ;else jump to 'end1'
next:
   ld (hl),255                          ;reset first byte of counter
   inc hl                               ;point hl to second byte of counter
   dec (hl)                             ;decrement second byte
   jr nz,end1                           ;if second byte is not zero, counting
                                        ;is not done.. jump to 'end1'

   call $0C29                           ;If you want something else to happen..
                                        ;change call $0C29 to whatever you want
end2:                                   ;resets counter to original
   ld hl,var1                           ;loads counter into hl
   ld (hl),70                           ;loads first byte with 70
   inc hl                               ;points hl to second byte
   ld (hl),17                           ;loads second byte with 17
end1:
   pop bc                               ;restore saved registers
   pop hl
   pop af
   ret                                  ;returns

var1 equ $-int+_user_int_ram+1          ;counter with address adjusted for the
   .db 140,34                           ;interrupt handlers address
int_end:

.end


